/**
 * JASMINe
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ApplicationDiscoveryService.java 6736 2010-07-22 12:06:56Z veyjul $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.agent.common.discovery;

import java.util.List;

/**
 * Inteface describing an application discovery service
 * 
 * @author Julien Vey
 */
public interface ApplicationDiscoveryService {

    /**
     * get the type of the service
     * 
     * @return the type of the service
     */
    String getType();

    /**
     * discover the instances of the application installed on the system
     * 
     * @return the list of application discovered
     */
    List<Application> discoverApplications();

    /**
     * get the id of the service (corresponding to the agent id)
     * 
     * @return the id of the service
     */
    String getId();

}
